/* redirect.c -- send back a redirect for a chosen URL

	Copyright 1999,2005,2006
		by Mark E. Mallett, MV Communications, Inc.

	See the package's "LICENSE" file for terms.

Used as the target of an HTML form to pass back a redirected
URL reference to the browser.  The form passes the URL in the
"redirect-url" tag and this CGI program emits a response directing
the client browser to that new URL.

*/


#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <limits.h>

#include "mvform.h"

#include <mml/mml-alloc.h>
#include <mml/mml-ll.h>
#include <mml/mml-str.h>
#include <mml/mml-in.h>
#include <mml/mml-iopf.h>
#include <mml/mml-cgi.h>

#include "formmisc.h"


/* Local Definitions */


/* External data referenced */


/* External routines used */

extern	char	*getenv();

/* Local data publicly available */

    /* These are not used; they need to exist to satisfy linker references
       because we use some non-related function in an external module.
    */
	char	*DocumentRootP;		/* Document root */
	char	Formdir[PATH_MAX +1];	/* Dir for this form */

/* Local routines and forward references */


/* Private data */


main( argc, argv )
	int		argc;
	char		**argv;
{
	char		*errP;
	char		*newurlP;	/* Ptr to the new URL */
	char		*qP;		/* Ptr to qarg */
	char		*strP;

    /* put stderr onto stdout */
    close( 2 );
    dup2( 1, 2 );

    /* Referer must come from our site.  This is a hack. */
    strP = getenv( "HTTP_REFERER" );
    if ( ( strP == NULL ) || ( *strP == NUL ) ||
         ( ( strnicmp( strP, "http://www.mv.com/", 18 ) != 0 ) &&
	   ( strnicmp( strP, "https://www.mv.com/", 19 ) != 0 ) ) ) {
	report_error( "Invalid referrer \"%s\"",
		     strP == NULL ? "" : strP );
	exit( 0 );
    }

    /* Collect arguments */
    if ( ( errP = qargs_in( (char *)NULL ) ) != NULL ) {
	report_error( errP );
	exit( 0 );
    }

    /* Find the redirect-url tag */
    if ( ( qP = qarg_find_tag( "redirect-url" ) ) == NULL ) {
	report_error(
	"The redirect-url tag was not properly passed by the invoking form." );
	exit( 0 );
    }

    newurlP = qarg_value( qP );		/* The new URL */

    /* Emit the rest of the header, with the new location ref. */
    printf( "Location: %s\n", newurlP );
    printf( "Status: 302\n" );
    printf( "Connection: close\n" );
    begin_doc_out();


    /* Give a document in case the redirection didn't work. */
#if 1
    printf( "<title> Redirection to %s </title>\n", newurlP );
    printf( "<h1> Redirection to %s </h1>\n", newurlP );
    printf( "You are now requested to go to <br>\n" );
#endif
    printf( "<a href=\"%s\"> %s </a>\n", newurlP, newurlP );

    fflush( stdout );
}
